--[[
1.0.9 06/26/2021 toc update for 9.1.0; added toc for The Burning Crusade Classic
1.0.8 03/13/2021 toc update for 9.0.5
1.0.7 10/12/2020 toc update for 9.0
1.0.6 08/29/2017 toc udpate for 7.3
1.0.5 03/28/2017 added bindings to cycle party and raid, updated toc for 7.2
1.0.4 07/19/2016 toc update for 7.0
1.0.3 02/23/2015 toc update for 6.1
1.0.2 02/24/2015 toc update for 6.1
1.0.1 10/14/2014 toc update for 6.0
1.0.0 03/31/2014 initial release
]]

-- binding definitions
BINDING_HEADER_CYCLEARENA = "Cycle Arena"
_G["BINDING_NAME_CLICK CycleArenaTarget:LeftButton"] = "Cycle Arena Target Forward"
_G["BINDING_NAME_CLICK CycleArenaTarget:RightButton"] = "Cycle Arena Target Backward"
_G["BINDING_NAME_CLICK CycleArenaFocus:LeftButton"] = "Cycle Arena Focus Forward"
_G["BINDING_NAME_CLICK CycleArenaFocus:RightButton"] = "Cycle Arena Focus Backward"
_G["BINDING_NAME_CLICK CyclePartyTarget:LeftButton"] = "Cycle Party Target Forward"
_G["BINDING_NAME_CLICK CyclePartyTarget:RightButton"] = "Cycle Party Target Backward"
_G["BINDING_NAME_CLICK CyclePartyFocus:LeftButton"] = "Cycle Party Focus Forward"
_G["BINDING_NAME_CLICK CyclePartyFocus:RightButton"] = "Cycle Party Focus Backward"
_G["BINDING_NAME_CLICK CycleRaidTarget:LeftButton"] = "Cycle Raid Target Forward"
_G["BINDING_NAME_CLICK CycleRaidTarget:RightButton"] = "Cycle Raid Target Backward"
_G["BINDING_NAME_CLICK CycleRaidFocus:LeftButton"] = "Cycle Raid Focus Forward"
_G["BINDING_NAME_CLICK CycleRaidFocus:RightButton"] = "Cycle Raid Focus Backward"

-- create a secure button for each binding
for k,name in pairs({"CycleArenaTarget","CycleArenaFocus","CyclePartyTarget","CyclePartyFocus","CycleRaidTarget","CycleRaidFocus"}) do
	local button = CreateFrame("Button",name,nil,"SecureActionButtonTemplate")
	-- set up persistent attributes to describe the button's behavior
	button:SetAttribute("maxUnits",k<=4 and 5 or 40)
	button:SetAttribute("unitType",k<=2 and "arena" or k<=4 and "party" or "raid")
	button:SetAttribute("unitIndex",0)
	local targetType = k%2==0 and "focus" or "target"
	button:SetAttribute("type1",targetType)
	button:SetAttribute("type2",targetType)
	-- create a pre-click snippet to increment/decrement unit
	SecureHandlerWrapScript(button,"OnClick",button,[[
		local maxUnits = self:GetAttribute("maxUnits") -- 5 for arena, 5 for party, 40 for raid
		local unitType = self:GetAttribute("unitType")
		local index = self:GetAttribute("unitIndex") -- number 0-X of last seen unit
		local direction = button=="RightButton" and -1 or 1
		for i=1,maxUnits do
			index = (index+direction)%5
			local unit = unitType..index+1
			if unit=="party5" then
				unit = "player" -- for party targeting, 5th unit is player
			end
			if UnitExists(unit) then
				self:SetAttribute("unitIndex",index)
				self:SetAttribute("unit",unit)
				return
			end
		end
		self:SetAttribute("unit",nil) -- if no unit, don't target
	]])
end
